Summary: Tool to manage your infrastructure
Name: salt
Version: 2017.7.1
Release: alt0.M80P.1
Url: http://saltstack.org
#VCS: https://github.com/saltstack/salt
License: apache-2.0
Group: System/Configuration/Other

Packager: Andrey Cherepanov <cas@altlinux.org>

Source0: %name-%version.tar
Source1: master.logrotate
Source2: minion.logrotate
Source3: salt-api.init
Source4: salt-master.init
Source5: salt-minion.init
Source6: salt-syndic.init

BuildRequires: python-module-setuptools perl-podlators
BuildRequires: python-module-nose libzeromq-devel
BuildRequires: python-module-zmq-devel python-module-Crypto
BuildRequires: python-module-msgpack python-module-yaml

BuildArch: noarch

%add_python_req_skip win32api win32event win32service win32serviceutil winerror pythoncom distutils

# For more detailed autoreqs (under jnpr.*), which can be satisfied;
# this fixes the general UNMET python2.X(jnpr), which used to appear.
%python_req_hier
# except "virtual" Provides of six.py, which cannot be autogenerated:
%global to_filter_moves %py_dependencies salt\.ext\.six\.moves.*
# {0} is to strip a space at the end:
%filter_from_requires s:%to_filter_moves\{0\}::g
%filter_from_requires \,\(/sbin/chkconfig\|/usr/bin/pip\|apt\|curl\|erlang\|ftp\|gawk\|git-core\|grep\|initctl\|local/s*bin\|lxc\|make\|perl-Package\|python-base\|python-module-setuptools\|python-module-virtualenv\|rpm\|salt-minion\|service\|sudo\|systemctl\|systemd\|wget\|yum-config-manager\|rc-update\),d

%description
Salt is a distributed remote execution system used to execute commands
and query data. It was developed in order to bring the best solutions
found in the world of remote execution together and make them better,
faster and more malleable. Salt accomplishes this via its ability to
handle larger loads of information, and not just dozens, but hundreds,
or even thousands of individual servers. It handles them quickly and
through a simple yet manageable interface.

%package -n python-module-salt
Summary: Management component for salt, a parallel remote execution system
Group: Development/Python
Requires: python-module-yaml python-module-msgpack python-module-json

%description  -n python-module-salt
Salt is a distributed remote execution system used to execute commands
and query data. It was developed in order to bring the best solutions
found in the world of remote execution together and make them better,
faster and more malleable. Salt accomplishes this via its ability to
handle larger loads of information, and not just dozens, but hundreds,
or even thousands of individual servers. It handles them quickly and
through a simple yet manageable interface.

%package -n python-module-salt-tests
Summary: Test files for management component for salt, a parallel remote execution system
Group: Development/Python
Requires: python-module-yaml python-module-msgpack python-module-json

%description  -n python-module-salt-tests
Salt is a distributed remote execution system used to execute commands
and query data. It was developed in order to bring the best solutions
found in the world of remote execution together and make them better,
faster and more malleable. Salt accomplishes this via its ability to
handle larger loads of information, and not just dozens, but hundreds,
or even thousands of individual servers. It handles them quickly and
through a simple yet manageable interface.

%package master
Summary: Management component for salt, a parallel remote execution system
Group: System/Configuration/Other
Requires: python-module-salt = %version-%release

%description master
The Salt master is the central server to which all minions connect.

%package minion
Summary: Client component for salt, a parallel remote execution system
Group: System/Configuration/Other
Requires: python-module-salt = %version-%release

%description minion
Salt minion is queried and controlled from the master.

%package api
Summary: API for salt
Group: System/Configuration/Other
Requires: python-module-salt = %version-%release

%description api
salt-api is a modular interface on top of Salt that can provide
a variety of entry points into a running Salt system. It can start
and manage multiple interfaces allowing a REST API to coexist
with XMLRPC or even a Websocket API.

%prep
%setup

%build
%python_build

%install
%python_build_install --prefix=/usr

# Add some directories
install -d -m 0755 %buildroot%_var/log/salt
touch %buildroot%_var/log/salt/minion
touch %buildroot%_var/log/salt/master
install -d -m 0755 %buildroot%_var/cache/salt
install -d -m 0755 %buildroot%_sysconfdir/salt
install -d -m 0755 %buildroot%_sysconfdir/salt/master.d
install -d -m 0755 %buildroot%_sysconfdir/salt/minion.d
install -d -m 0755 %buildroot%_sysconfdir/salt/pki
install -d -m 0755 %buildroot%_sysconfdir/salt/pki/master
install -d -m 0755 %buildroot%_sysconfdir/salt/pki/minion
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.conf.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.deploy.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.maps.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.profiles.d
install -d -m 0755 %buildroot%_sysconfdir/salt/cloud.providers.d
install -d -m 0755 %buildroot%_sysconfdir/salt/proxy.d

install -D -m 755 %SOURCE4 %buildroot%_initdir/salt-master
install -D -m 755 %SOURCE6 %buildroot%_initdir/salt-syndic
install -D -m 755 %SOURCE5 %buildroot%_initdir/salt-minion
install -D -m 755 %SOURCE3 %buildroot%_initdir/salt-api

mkdir -p %buildroot%_unitdir
install -p -m 0644 pkg/salt-master.service %buildroot%_unitdir/
install -p -m 0644 pkg/salt-syndic.service %buildroot%_unitdir/
install -p -m 0644 pkg/salt-minion.service %buildroot%_unitdir/
install -p -m 0644 pkg/salt-api.service %buildroot%_unitdir/

mkdir -p %buildroot%_sysconfdir/salt/
install -p -m 0640 conf/minion %buildroot%_sysconfdir/salt/minion
install -p -m 0640 conf/master %buildroot%_sysconfdir/salt/master
install -p -m 0640 conf/cloud  %buildroot%_sysconfdir/salt/cloud
install -p -m 0640 conf/roster %buildroot%_sysconfdir/salt/roster
install -p -m 0640 conf/proxy  %buildroot%_sysconfdir/salt/proxy

mkdir -p %buildroot%_sysconfdir/sysconfig
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-master
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-syndic
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-minion
echo "ARG=''" >  %buildroot%_sysconfdir/sysconfig/salt-api

install -D -m 0644 pkg/salt.bash %buildroot%_sysconfdir/bash_completion.d/salt

install -D -m 0644 %SOURCE1 %buildroot%_sysconfdir/logrotate.d/salt-master
install -D -m 0644 %SOURCE2 %buildroot%_sysconfdir/logrotate.d/salt-minion

#TODO: temp fix
#rm -rf %python_sitelibdir/salt/cloud/deploy
#rm -rf %buildroot%python_sitelibdir/salt/cloud/deploy

#create symlink for opennode
#cd %buildroot%python_sitelibdir/salt/modules
#ln -s ../../opennode/cli/actions onode

#check
#__python setup.py test --runtests-opts=-u

%post master
%post_service salt-master
%post_service salt-syndic

%preun master
%preun_service salt-master
%preun_service salt-syndic

%post minion
%post_service salt-minion

%preun minion
%preun_service salt-minion

%files -n python-module-salt
%doc AUTHORS README* LICENSE HACKING.rst
%config(noreplace) %dir %_sysconfdir/salt
%config(noreplace) %dir %_sysconfdir/salt/pki
%exclude %python_sitelibdir/salt/daemons/test
%python_sitelibdir/*
%_man7dir/salt.7.*

%files -n python-module-salt-tests
%dir %python_sitelibdir/salt/daemons/test
%python_sitelibdir/salt/daemons/test/*

%files master
%config(noreplace) %_sysconfdir/salt/master
%config(noreplace) %_sysconfdir/salt/master.d
%config(noreplace) %_sysconfdir/salt/roster
%config %_sysconfdir/bash_completion.d/*
%config(noreplace) %dir %_sysconfdir/bash_completion.d
%config(noreplace) %_sysconfdir/logrotate.d/salt-master
%config(noreplace) %_sysconfdir/salt/pki/master
%config(noreplace) %_sysconfdir/sysconfig/salt-master
%config(noreplace) %_sysconfdir/sysconfig/salt-syndic
%_sysconfdir/salt/cloud.conf.d
%_sysconfdir/salt/cloud.deploy.d
%_sysconfdir/salt/cloud.maps.d
%_sysconfdir/salt/cloud.profiles.d
%_sysconfdir/salt/cloud.providers.d
%config(noreplace) %_sysconfdir/salt/cloud
%ghost %_logdir/salt/master
%_var/cache/salt

%_initdir/salt-master
%_initdir/salt-syndic

%_unitdir/salt-master.service
%_unitdir/salt-syndic.service

%_bindir/salt
%_bindir/salt-master
%_bindir/salt-syndic
%_bindir/salt-cloud
%_bindir/salt-cp
%_bindir/salt-key
%_bindir/salt-run
%_bindir/salt-ssh
%_bindir/spm
%_bindir/salt-unity

%_man1dir/salt.1.*
%_man1dir/salt-master.1.*
%_man1dir/salt-cp.1.*
%_man1dir/salt-cloud.1.*
%_man1dir/salt-key.1.*
%_man1dir/salt-run.1.*
%_man1dir/salt-syndic.1.*
%_man1dir/salt-ssh.1.*
%_man1dir/spm.1.*
%_man1dir/salt-unity.1.*

%files api
%config(noreplace) %_sysconfdir/sysconfig/salt-api
%_bindir/salt-api
%_initdir/salt-api
%_unitdir/salt-api.service
%_man1dir/salt-api.1.*

%files minion
%config(noreplace) %_sysconfdir/salt/minion
%config(noreplace) %_sysconfdir/salt/minion.d
%config(noreplace) %_sysconfdir/salt/proxy
%config(noreplace) %_sysconfdir/logrotate.d/salt-minion
%config(noreplace) %_sysconfdir/sysconfig/salt-minion
%config(noreplace) %_sysconfdir/salt/pki/minion
%ghost %_logdir/salt/minion

%_initdir/salt-minion
%_unitdir/salt-minion.service

%_bindir/salt-call
%_bindir/salt-minion
%_bindir/salt-proxy

%_man1dir/salt-call.1.*
%_man1dir/salt-minion.1.*
%_man1dir/salt-proxy.1.*

%changelog
* Wed Aug 16 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7.1-alt0.M80P.1
- Backport new version to p8 branch

* Wed Aug 16 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7.1-alt1
- New version

* Fri Jul 14 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7.0-alt0.M80P.1
- Backport new version to p8 branch

* Thu Jul 13 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7.0-alt1
- New version

* Thu Jun 15 2017 Andrey Cherepanov <cas@altlinux.org> 2017.7-alt1
- New version

* Fri Apr 07 2017 Andrey Cherepanov <cas@altlinux.org> 2017.5-alt1
- New version

* Thu Mar 30 2017 Andrey Cherepanov <cas@altlinux.org> 2016.11.3-alt1
- New version
- Remove optional external executables from autoreq

* Mon Feb 27 2017 Andrey Cherepanov <cas@altlinux.org> 2016.11.1-alt1
- New version 2016.11.1
- Package new files and directories
- Restore init and logrotate files

* Fri Nov 18 2016 Lenar Shakirov <snejok@altlinux.ru> 2016.3.4-alt1
- 2016.3.4

* Thu Sep 08 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt4
- Add extra dependiens because master won't start

* Thu Sep 08 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt3
- Rebuild with last commits from develop branch

* Thu Sep 08 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt2
- Rebuild with new python-module-tornado
- (previous version of tornado was without file locks.py)

* Fri Sep 02 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2016.3.3-alt1
- New version (ALT 32464)

* Thu Jun 16 2016 Ivan Zakharyaschev <imz@altlinux.org> 2015.8.7-alt2
- %%python_req_hier -- for more detailed autoreqs (under jnpr.*),
  without the general UNMET python2.X(jnpr).

* Mon Feb 29 2016 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.8.7-alt1
- New version

* Mon Aug 31 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.5.5-alt1
- New version

* Fri May 29 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.5.1-alt3
- New version

* Sat Apr 18 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.2-alt3
- Removed code from previous tag (ALT 30929)

* Thu Feb 12 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.2-alt2
- Add subpackage python-module-salt-tests

* Mon Feb 02 2015 Valentin Rosavitskiy <valintinr@altlinux.org> 2015.2-alt1
- New version

* Wed Dec 10 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 2014.7-alt3
- Add subpackage salt-api

* Mon Nov 03 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 2014.7-alt2
- Fix repocop info symlink-extra-slash

* Tue Oct 28 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 2014.7-alt1
- New version

* Tue May 13 2014 Valentin Rosavitskiy <valintinr@altlinux.org> 0.17.5-alt1
- New version

* Fri Jan 10 2014 Slava Dubrovskiy <dubrsl@altlinux.org> 0.17.4-alt1
- New version

* Sun Nov 24 2013 Slava Dubrovskiy <dubrsl@altlinux.org> 0.17.2-alt1
- New version

* Sat Sep 28 2013 Slava Dubrovskiy <dubrsl@altlinux.org> 0.17.0-alt1
- New version

* Wed Jan 02 2013 Slava Dubrovskiy <dubrsl@altlinux.org> 0.11.1-alt3
- Update spec
- Fix init scripts

* Mon Dec 24 2012 Slava Dubrovskiy <dubrsl@altlinux.org> 0.11.1-alt2
- New version

* Thu Dec 06 2012 Slava Dubrovskiy <dubrsl@altlinux.org> 0.10.5-alt1
- Build for ALT
